<template>
  <div class="m-character-stats-counter">
    <div v-if="editable">
      <el-input-number
        v-model="point"
        :min="current"
        :max="point + available"
        @change="change"
      />
    </div>
    <div v-else class="m-character-stats-counter__point">
      {{ point }}
    </div>
  </div>
</template>

<script>
import "../scss/m-character-stats-counter.scss";

export default {
  name: "MStatsCounter",
  props: {
    value: {},
    current: {
      type: Number,
      required: true,
    },
    available: {
      type: Number,
      required: false,
      default: 0,
    },
    editable: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      point: this.value,
    };
  },
  methods: {
    change(newValue, oldValue) {
      this.$emit("input", newValue);
      this.$emit("change", this.available + (oldValue - newValue));
    },
  },
  watch: {
    value() {
      this.point = this.value;
    },
  },
};
</script>
